
#import "ControllerObject.h"
#import "HP48Object.h"
extern mutex_t timerMutex;
@implementation ControllerObject

- appDidInit:sender
{
    [self newCalculator:self];
    return self;
}

- terminate:sender
{
    mutex_lock(timerMutex);
    do_save(0,0,0);
    mutex_unlock(timerMutex);
    [NXApp terminate:self];
}

- appWillTerminate:sender
{
 
    return self;
}

- showInfoPanel:sender
{
    if (!infoPanel) {
	if (![NXApp loadNibSection:"info.nib" owner:self withNames:NO]) {
	    NXLogError ("Could not load info.nib");
	}
    }
    [infoPanel makeKeyAndOrderFront:self];
    return self;
}

- newCalculator:sender
{
	if (!HPCalculator) HPCalculator=[[HP48Object alloc] init];
	return self;
}

- showConsole:sender
{
	if (HPCalculator) [HPCalculator showConsole:self];
	return self;
}
@end
