// IMPORTS

#import <appkit/appkit.h>


// DEFINES

//#define COLOR_VIEW 1			// undefine for black/white view.

# define KEY_DELAY 10			// milliseconds delay for keyup (was 150)

# define	ROWS	70
# define	COLUMNS	140

# define	BROWS	140
# define	BCOLUMNS	280

#if defined(COLOR_VIEW)

#define PIXEL 			unsigned short
#define BITS_PER_SAMPLE	4
#define SAMPLES_PER_PIXEL	4
#define HAS_ALPHA		YES
#define IS_PLANAR		NO
#define COLOR_SPACE		NX_RGBColorSpace
#define COLOR_0			(unsigned short)0x6078 // grey/green
#define COLOR_1			(unsigned short)0x2011 // darkish blue

#else

#define PIXEL			unsigned char
#define BITS_PER_SAMPLE	8
#define SAMPLES_PER_PIXEL	1
#define HAS_ALPHA		NO
#define IS_PLANAR		NO
#define COLOR_SPACE		NX_OneIsBlackColorSpace
#define COLOR_0			(unsigned char)0
#define COLOR_1			(unsigned char)255

#endif

#define BITS_PER_PIXEL (SAMPLES_PER_PIXEL * BITS_PER_SAMPLE)
#define BYTES_PER_SAMPLE (BITS_PER_PIXEL / 8)
#define BB	COLOR_0
#define WW	COLOR_1


// INTERFACE

@interface HP48View:View
{
	int nRedrawCount;
	NXImage *backGround;
	NXBitmapImageRep *LCD;
	NXImage *LCDImage;
	id	receiver;
	int	nDisplayType;
	NXRect imRect;
	NXSize imSize;
	int xSize;
	int ySize;
	unsigned char *data[5];
	int nVEventState;
	BOOL alpha, leftShift, rightShift;
}
- initFrame:(const NXRect *)frm;
- drawSelf:(NXRect *)rects :(int)rectCount;

- declareReceiver:sender;

@end

// "GLOBAL" DATA

extern PIXEL	lcd_buffer[ROWS][COLUMNS];
extern PIXEL	biglcd_buffer[BROWS][BCOLUMNS];
