/*
 * Convert hp48sx hex ROM output to binary ROM image file for em48
 *
 * Hannu.Aronsson@cs.hut.fi, version 1.0
 *
 * Usage: ./fixdump <hp48.dmp >rom
 *
 * This uses a very simple state machine to do the conversion
 *
 */

#include <stdio.h>

#define OUT 0
#define FIRST 1
#define SECOND 2

int hex2(c) {
        if (c >= '0' && c <= '9') return c-'0';
        if (c >= 'A' && c <= 'F') return c-'A'+10;
        if (c >= 'a' && c <= 'f') return c-'a'+10;
        return -1;
}

main() { 
        int c, state = OUT;
        int num;

        while((c=getchar()) != EOF) {
                switch(state) {
                case OUT:
                        if (c==':') state=FIRST;
                        break;
                case FIRST:
                        num = hex2(c);
                        if (num<0)
                                state = OUT;
                        else
                                state = SECOND;
                        break;
                case SECOND:
#if 0
                        num = num * 16 + hex2(c);
#else
                        num = num + 16 * hex2(c);
#endif
                        putchar(num);
                        state= FIRST;
                } /* switch */
        } /* while getchar */
} /* main */

