# include	"hp48.h"
#include "dis48.h"
# include	<string.h>

int	relative_addr;

char *
#ifdef ANSI
Append16(char *buf, int n)
#else
Append16(buf, n)
char	*buf;
int	n;
#endif
{
	if (++n > 9) {
		APPEND_CHAR(buf, '1');
		n -= 10;
	}
	
	APPEND_BDIGIT(buf, n);
	TERMINATE(buf);
	return(buf);
}

char *
#ifdef ANSI
AppendAddr(char *buf, NAddr addr)
#else
AppendAddr(buf, addr)
char	*buf;
NAddr	addr;
#endif
{
	int	shift;
	long	mask;
	symtab_t	*sp;

	APPEND_HEXMARK(buf);
	for (mask = 0xf0000L, shift = 16; mask != 0; mask >>= 4, shift -= 4)
		APPEND_CHAR(buf, hex[(addr & mask) >> shift]);
	TERMINATE(buf);
	if (!relative_addr) {
		sp = lookup_by_addr(addr);
		if (sp) {
			*buf++ = ' ';
			strcpy(buf, sp->comment);
			buf += strlen(buf);
			}
		}
	
	return(buf);
}

char *
#ifdef ANSI
AppendRAddr(char *buf, NAddr pc, long disp, int n, int offset)
#else
AppendRAddr(buf, pc, disp, n, offset)
char	*buf;
NAddr	pc;
long	disp;
int	n;
int	offset;
#endif
{
	long	sign;

	sign = 1L << (n * 4 - 1);
	if (disp & sign)
		disp |= ~(sign - 1);
		
	pc += disp;
	target = pc;
	buf = AppendStr(buf, "pc");
	if (disp < 0) {
		APPEND_CHAR(buf, '-');
		disp = -disp - offset;
	} else {
		APPEND_CHAR(buf, '+');
		disp += offset;
	}

	relative_addr = 1;		
	buf = AppendAddr(buf, disp);
	relative_addr = 0;		
	buf = AppendStr(buf, " (");
	buf = AppendAddr(buf, pc);
	APPEND_CHAR(buf, ')');
	TERMINATE(buf);
	return(buf);
}

char *
#ifdef ANSI
AppendField(char *buf, Nybble fn)
#else
AppendField(buf, fn)
char	*buf;
Nybble	fn;
#endif
{
	while (*buf != '\0')
		buf++;
		
	APPEND_CHAR(buf, '.');
	switch (fn) {
	case 0: APPEND_CHAR(buf, 'p'); break;
	case 1: 
		APPEND_CHAR(buf, 'w');
		APPEND_CHAR(buf, 'p');
		break;
	case 2:
		APPEND_CHAR(buf, 'x');
		APPEND_CHAR(buf, 's');
		break;
	case 3:
		APPEND_CHAR(buf, 'x');
		break;
	case 4: APPEND_CHAR(buf, 's'); break;
	case 5: APPEND_CHAR(buf, 'm'); break;
	case 6: APPEND_CHAR(buf, 'b'); break;
	case 7: APPEND_CHAR(buf, 'w'); break;
	case 0xf: APPEND_CHAR(buf, 'a'); break;
	default: APPEND_CHAR(buf, '?'); break;
	}
	
	APPEND_TAB(buf);
	TERMINATE(buf);
	return(buf);
}

char *
#ifdef ANSI
AppendHexNyb(char *buf, NAddr *addr, int n)
#else
AppendHexNyb(buf, addr, n)
char	*buf;
NAddr	*addr;
int	n;
#endif
{
	extern long symbolic_addr;
	int	i;
	Nybble	t[16];

	APPEND_HEXMARK(buf);
	for (i = 0; i < n; i++)
		t[i] = get_nibble((*addr)++);

	if (n == 5) {
		symbolic_addr = ((long) t[4] << 16) |
			(unsigned short) ((t[3] << 12) | (t[2] << 8) | (t[1] << 4) | t[0]);
		}
	else if (n == 4) {
		symbolic_addr = 0x70000L |
			(unsigned short) ((t[3] << 12) | (t[2] << 8) | (t[1] << 4) | t[0]);
		}

	while (--i >= 0)
		APPEND_CHAR(buf, hex[t[i]]);

	TERMINATE(buf);
	return(buf);
}

char *
#ifdef ANSI
AppendDecInt(char *buf, int n)
#else
AppendDecInt(buf, n)
char	*buf;
int	n;
#endif
{
	int	i;
	char	b[9];
	
	if (n < 0) {
		APPEND_CHAR(buf, '-');
		n = -n;
	}
	
	for (i = 0; n != 0; i++, n /= 10)
		b[i] = (char) (n % 10 + '0');
	
	while (--i >= 0)
		APPEND_CHAR(buf, b[i]);

	TERMINATE(buf);
	return(buf);
}

char *
#ifdef ANSI
AppendImmNyb(char *buf, NAddr *addr, int n)
#else
AppendImmNyb(buf, addr, n)
char	*buf;
NAddr	*addr;
int	n;
#endif
{
	APPEND_IMMMARK(buf);
	return(AppendHexNyb(buf, addr, n));
}

#define NSTBIT	4
char	*StBitStr[NSTBIT] = {"xm", "sb", "sr", "mp"};

char *
#ifdef ANSI
AppendStBits(char *buf, int n)
#else
AppendStBits(buf, n)
char	*buf;
int	n;
#endif
{
	int	i;
	char	*p, *q;
	
	for (p = buf, i = 0; i < NSTBIT; i++)
		if (n & (1 << i)) {
			if (p != buf) {
				APPEND_COMMA(p);
			}
			
			/* p = AppendStr(p, StBitStr[i]); */
			q = StBitStr[i];
			while (*p = *q++)
				p++;
		}
	
	TERMINATE(p);
	return(p);
}

char *
#ifdef ANSI
AppendStr(char *buf, char *str)
#else
AppendStr(buf, str)
char	*buf;
char	*str;
#endif
{
	while (*buf = *str++)
		buf++;
	
	return(buf);
}
