#include "hp48.h"
#include "dis48.h"
extern char acOut[512];
extern CPU cpu;
/**********************************************************************/
/*   Variable set by disassembler to hint at values to be shown	      */
/*   symbolically.						      */
/**********************************************************************/
long	symbolic_addr;

#ifdef ANSI
NAddr	Instruction(NAddr addr, char *istr);
#else
NAddr	Instruction();
#endif

IType	itype;
NAddr	target;

char	*itypestr[] = {"other", "branch", "call", "jump", "ujump"};

WORD20
#ifdef ANSI
Disassemble(NAddr start, NAddr end)
#else
Disassemble(start, end)
NAddr	start;
NAddr	end;
#endif
{
	NAddr	addr, next;
	int	i, nybs;
	char	*p;
	char	buf[BUFSIZ];
	char	istr[BUFSIZ];
	symtab_t	*sp;

	for (addr = start; addr < end; addr = next) {
		itype = other;
		target = NOADDR;
		symbolic_addr = 0;
		next = Instruction(addr, istr);
		nybs = (int) (next - addr);
		p = AppendAddr(buf, addr);
		APPEND_CHAR(p, ':');
		APPEND_TAB(p);
		for (i = 7; (i > 0) && (nybs > 0); i--, nybs--)
			APPEND_CHAR(p, hex[get_nibble(addr++)]);
		
		APPEND_TAB(p);
		print("%.*s %s", p - buf, buf, istr);
		if (symbolic_addr) {
			sp = lookup_by_addr(symbolic_addr);
			if (sp)
				print("; %s", sp->comment);
			}
		print("\n");
		while (nybs > 0) {
			p = AppendAddr(buf, addr);
			APPEND_CHAR(p, ':');
			APPEND_TAB(p);
			for (i = 7; (i > 0) && (nybs > 0); i--, nybs--)
				APPEND_CHAR(p, hex[get_nibble(addr++)]);
		
			print("%.*s\n", p - buf, buf);
		}
	}
	return addr;
}
NAddr
Instruction_length(addr)
NAddr	addr;
{
	char	istr[BUFSIZ];
	itype = other;
	target = NOADDR;
	return Instruction(addr, istr);
}
#ifndef MY48
int
#ifdef ANSI
get_nibble(NAddr addr)
#else
get_nibble(addr)
NAddr	addr;
#endif
{
	if (addr & 1)
		return cpu.rom[addr >> 1] >> 4;
	else
		return cpu.rom[addr >> 1] & 0x0f;
}
#endif
long
#ifdef ANSI
GetInt(NAddr *addr, int n)
#else
GetInt(addr, n)
NAddr	*addr;
int	n;
#endif
{
	int	i;
	long	t = 0;
	
	for (i = 0; i < n; i++)
		t |= ((long) get_nibble((*addr)++)) << (i * 4);
		
	return(t);
}

