/**********************************************************************/
/*   Drawing  area  widget -- allows application to draw into window  */
/*   and be called when certain events occur. Very primitive widget.  */
/**********************************************************************/
# include <X11/copyright.h>

/* $XConsortium: Template.h,v 1.4 89/07/21 01:41:49 kit Exp $ */

#ifndef _Draw_h
#define _Draw_h

# if	defined(X11r3)
#	define	XtPointer	void *
# endif
/****************************************************************
 *
 * Draw widget
 *
 ****************************************************************/

/* Resources:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		Pixel		XtDefaultBackground
 border		     BorderColor	Pixel		XtDefaultForeground
 borderWidth	     BorderWidth	Dimension	1
 destroyCallback     Callback		Pointer		NULL
 height		     Height		Dimension	0
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 sensitive	     Sensitive		Boolean		True
 width		     Width		Dimension	0
 x		     Position		Position	0
 y		     Position		Position	0

ctwWidget:
 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 resizeCallback	     ResizeCallback	Callback	NULL
 exposeCallback	     ExposeCallback	Callback	NULL
 foreground	     Foreground 	Pixel		XtDefaultForeground
*/

/**********************************************************************/
/*   define  any  special  resource  names  here  that  are  not  in  */
/*   <X11/StringDefs.h>						      */
/**********************************************************************/

#define	XtNresizeCallback "resizeCallback"
#define	XtNexposeCallback "exposeCallback"

#define	XtCResizeCallback "ResizeCallback"
#define	XtCExposeCallback "ExposeCallback"

/**********************************************************************/
/*   declare specific DrawWidget class and instance datatypes	      */
/**********************************************************************/

typedef struct _DrawClassRec*	DrawWidgetClass;
typedef struct _DrawRec*		DrawWidget;

/**********************************************************************/
/*   declare the class constant					      */
/**********************************************************************/

extern WidgetClass drawWidgetClass;

/**********************************************************************/
/*   Following  macro  used  to  allow  compilation  with ANSI C and  */
/*   non-ANSI C compilers automatically.			      */
/**********************************************************************/
# if !defined(PROTO)
# 	if	defined(__STDC__)
#		define	PROTO(x)	x
#	else
#		define	PROTO(x)	()
#	endif
# endif

#endif /* _Draw_h */
