From comp.sys.hp48 Mon Mar 16 13:55:39 1992
Path: seq!rock!mcnc!uvaarpa!darwin.sura.net!europa.asd.contel.com!uunet!mcsun!news.funet.fi!funic!news.cs.hut.fi!cs.hut.fi!haa
From: haa@cs.hut.fi (Hannu Aronsson)
Newsgroups: comp.sys.hp48
Subject: HP48 Emulator -- how to turn hex dump into binary 'rom' image
Message-ID: <HAA.92Mar16162258@tahma.hut.fi>
Date: 16 Mar 92 14:22:58 GMT
Sender: usenet@huuhaa.cs.hut.fi (Uutis Ankka)
Distribution: comp
Organization: Helsinki University of Technology, Finland
Lines: 78


Hello, fellow hp48sxers.

The emulator needs a binary image of the rom.  With the instructions
in the source posting, you can get a *hex dump* of the ROM nibbles out
of your calculator.

So you will need to convert the hex dump into binary, but the order of
the nibbles is not too clear (for beginning hp48sxers like me, at
least).

With the following program, I managed to turn the hex listing into a
binary 'rom' file which the emulator *seems to* accept. I hope the
program proves useful. As usual, normal disclaimers apply.

---------clip-----clap------clipety------clic------clac----------
/*
 * Convert hp48sx hex ROM output to binary ROM image file for em48
 *
 * Hannu.Aronsson@cs.hut.fi, version 1.0
 *
 * Usage: ./fixdump <hp48.dmp >rom
 *
 * This uses a very simple state machine to do the conversion
 *
 */

#include <stdio.h>

#define OUT 0
#define FIRST 1
#define SECOND 2

int hex2(c) {
        if (c >= '0' && c <= '9') return c-'0';
        if (c >= 'A' && c <= 'F') return c-'A'+10;
        if (c >= 'a' && c <= 'f') return c-'a'+10;
        return -1;
}

main() { 
        int c, state = OUT;
        int num;

        while((c=getchar()) != EOF) {
                switch(state) {
                case OUT:
                        if (c==':') state=FIRST;
                        break;
                case FIRST:
                        num = hex2(c);
                        if (num<0)
                                state = OUT;
                        else
                                state = SECOND;
                        break;
                case SECOND:
#if 0
                        num = num * 16 + hex2(c);
#else
                        num = num + 16 * hex2(c);
#endif
                        putchar(num);
                        state= FIRST;
                } /* switch */
        } /* while getchar */
} /* main */
---------clip-----clap------clipety------clic------clac----------

Otherwise the em48 works just great, although I managed to "crash" it
a few times. I believe we'll see em48 ported to other environments,
unfortunately I don't have time to work on that myself :-(

rgds//haa
--
Hannu Aronsson <Hannu.Aronsson@cs.hut.fi>
Dept. of Computer Science, CS lab,
Helsinki University of Technology, Finland

